      1  REM [HEX:\
76,76,E7,CD,92,0D,E7,CD,\
92,0D,CD,F5,0B,79,D3,DF,\
78,D3,1F,DF,FE,1A,28,EA,\
ED,7B,02,40,C9]
     10 GOSUB 9000
#=======================================================
#PLAY TUNE
# CONVERT TONE TABLE VALUE TO CH A-B REG VALUES
# FOR EXAMPLE THE FIRST TWO NOTES OF THE SCORE
# ARE 53,32 SO...
# REG1=INT(J(53)/256)=0
# REG0=J(53)-REG1=55     CH A NOTE IS A=
# REG3=INT(J(32)/256)=0
# REG2=J(32)-REG1=185    CH B NOTE IS C=
#=======================================================
   1000 FOR X=1 TO LEN A$ STEP 6
   1010  LET N=VAL A$(X TO X+1)
   1020  LET AC=INT(J(N)/256)
   1030  LET AF=J(N)-AC
   1040  LET N=VAL A$(X+3 TO X+4)
   1050  LET BC=INT(J(N)/256)
   1060  LET BF=J(N)-AC
#SET CH A-B TONE, ENVELOPE SHAPE IF VOLUME=16
   1070  PRINT USR E,00,AF,01,AC,02,BF,03,BC,13,S
   1080  FOR D=1 TO T
   1090  NEXT D
   1100 NEXT X
#=======================================================
#CLEARSOUND
  5000 PRINT USR E,8,0,9,0,10,0,13,0
  5010 GOSUB 9300
  5020 GOTO 1000
#=======================================================
#INITIALIZE
  9000 LET E=16516
  9010 FAST
#=======================================================
#TONE TABLE DATA
  9020 LET A$="0000,1053,0994,"
#OCTAVE 2         c    c   d    d   e    f    f   g    g   a    a   b
  9030 LET A$=A$+"0938,0886,0836,0789,0745,0703,0664,0626,0591,0558,0527,0497,"
#OCTAVE 3 MIDDLE C
  9040 LET A$=A$+"0469,0443,0418,0395,0372,0351,0332,0313,0296,0279,0263,0248,"
#OCTAVE 4
  9050 LET A$=A$+"0235,0221,0209,0197,0186,0176,0166,0157,0148,0140,0132,0124,"
#OCTAVE 5
  9060 LET A$=A$+"0117,0111,0105,0099,0093,0088,0083,0078,0074,0070,0066,0062,"
#OCTAVE 6
  9070 LET A$=A$+"0059,0055,0052,0049,0047,0044,0041,0039,0037,0035,0033,0031,"
#OCTAVE 7
  9080 LET A$=A$+"0029,0028"
#=======================================================
  9090 DIM J(65)
  9100 LET X=1
  9110 FOR N=1 TO LEN A$ STEP 5
#9112 PRINT X;" ";A$(N TO N+3)
  9120  LET J(X)=VAL A$(N TO N+3)
  9130  LET X=X+1
  9140 NEXT N
#=======================================================
#THE SCORE EXAMPLE:53=USE J(53) FROM TONE TABLE
  9200 LET A$="53,32,55,31,56,29,56,29,55,34,53,34,52,36,52,36,53,34,55,"
  9210 LET A$=A$+"34,48,32,48,32,50,31,52,31,53,29,53,29,51,31,49,31,48,32,"
  9220 LET A$=A$+"48,32,46,34,44,34,43,36,43,36,44,34,46,34,48,32,46,32,44,"
  9230 LET A$=A$+"36,43,36,41,29,41,31,53,32,55,31,56,29,56,29,55,34,53,34,"
  9240 LET A$=A$+"52,36,52,36,53,34,55,34,48,32,48,32,50,31,52,31,53,29,53,"
  9250 LET A$=A$+"29,51,31,49,31,48,32,48,32,46,37,44,37,43,39,43,39,44,39,"
  9260 LET A$=A$+"44,39,32,44,32,44,01,01"
#=======================================================
#INPUT PARAMETERS
# EC=ENVELOPE PERIOD COARSE
# EF=ENVELOPE PERIOD FINE
#  S=ENVELOPE SHAPE
#  T=TEMPO
  9300 LET EC=0
  9310 LET EF=175
  9320 LET S=14
  9330 PRINT AT 21,0;"0-15=VOLUME  16=ENVELOPE"
  9340 INPUT V
  9350 IF V<16 THEN GOTO 9430
  9360 PRINT AT 0,0;"\
\
 0-SINGLE DECAY",,"\
 1-SINGLE ATTACK THEN HOLD","\
 4-SINGLE ATTACK THEN OFF","\
 6-SINGLE RISE",,"\                   
 8-FALLING SAWTOOTH CONTINUOUS  \
 9-SINGLE DECAY THEN OFF","\
10-CONTINUOUS RISE AND FALL     \
11-SINGLE DECAY THEN BACK 2 MAX \
12-RISING SAWTOOTH CONTINUOUS   \
13-RISE TO FULL VOL. THEN STEADY\
14-AS 10 WITH RISING VOLUME     \
15-SINGLE ATTACK THEN OFF","\
";AT 21,0;"\
SELECT ENVELOPE SHAPE.  "
  9370 INPUT S
  9380 IF S=2 OR S=3 OR S=5 OR S=7 OR S>15 THEN GOTO 9390
  9390 PRINT AT 21,0;"COARSE PERIOD? (EG 0)   "
  9400 INPUT EC
  9410 PRINT AT 21,0;"FINE PERIOD? (2-255 EG 175)"
  9420 INPUT EF
  9430 PRINT AT 21,0;"TEMPO? (EG 10)?            "
  9440 INPUT T
  9450 CLS
#=======================================================
#CH A VOLUME=V
#CH B VOLUME=V
#CH C VOLUME=0
#CH A-B TONE ENABLED
#SET ENVELOPE PERIOD COARSE
#SET ENVELOPE PERIOD FINE
  9500 PRINT USR E,8,V,9,V,10,0,7,60,11,EF,12,EC
  9510 RETURN
  9990 SAVE "ZX81TUNZ"
  9995 RUN
