;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Sound Command by zeddy-br from old forum thread
; "Sound board Zon-x AY-3-891x - commands please?"
; The syntax of it is:
; PRINT USR SOUND,R1,D1,R2,D2,R3,D3...
; where SOUND represents the address of the MC routine
; Rn is the AY register and Dn is the data to be written on AY register.
;================================

ORG 4084

@Sound
	RST 20		;Get next character
	CALL 0D92	;Evaluate a class-6 expression (AY register)
	RST 20 		;Get next character
	CALL 0D92	;Evaluate a class-6 expression (AY data)
	CALL 0BF5	;Stack-to-BC routine (AY register in C, AY data in B)
	LD A,C
	OUT (DF),A	;Set AY register
	LD A,B
	OUT (1F),A	;Write data to AY
	RST 18		;Collect a character
	CP ","		;Check for more parameters
	JR Z Sound
	LD SP,(4002) 	;Set SP from ERR_SP, skiping the PRINT routine
	RET
